import { Service, Context, Deferred, NextInvokeHandler, ServiceContext } from '@hprose/rpc-core';
export interface CallerContext<I extends object> extends ServiceContext {
    proxy: I;
    invoke<T>(name: string, args?: any[]): Promise<T>;
}
export declare class Caller {
    service: Service;
    private counter;
    protected calls: {
        [id: string]: [number, string, any[]][];
    };
    protected results: {
        [id: string]: {
            [index: number]: Deferred<any>;
        };
    };
    protected responders: {
        [id: string]: Deferred<[number, string, any[]][]>;
    };
    protected onlines: {
        [id: string]: boolean;
    };
    heartbeat: number;
    timeout: number;
    constructor(service: Service);
    protected id(context: ServiceContext): string;
    protected send(id: string, responder: Deferred<[number, string, any[]][]>): boolean;
    protected response(id: string): void;
    protected stop(context: ServiceContext): string;
    protected close(context: ServiceContext): void;
    protected begin(context: ServiceContext): Promise<[number, string, any[]][]>;
    protected end(results: [number, any, string][], context: ServiceContext): void;
    invoke(id: string, name: string, args?: any[]): Promise<any>;
    useService<T extends object>(id: string, namespace?: string): T;
    useService(id: string, names: string[]): any;
    useServiceAsync(id: string): Promise<any>;
    exists(id: string): boolean;
    idlist(): string[];
    protected handler: (name: string, args: any[], context: Context, next: NextInvokeHandler) => Promise<any>;
}
//# sourceMappingURL=Caller.d.ts.map