import { MissingMethod, MethodLike, Client, Context, InvokeHandler } from '@hprose/rpc-core';
export declare class ProviderContext extends Context {
    readonly client: Client;
    readonly method: MethodLike;
    constructor(client: Client, method: MethodLike);
}
export declare class Provider {
    readonly client: Client;
    private closed;
    debug: boolean;
    onerror?: (error: Error) => void;
    private readonly methodManager;
    private readonly invokeManager;
    constructor(client: Client, id?: string);
    get id(): string;
    set id(value: string);
    private execute;
    private process;
    private dispatch;
    listen(): Promise<void>;
    close(): Promise<void>;
    use(...handlers: InvokeHandler[]): this;
    unuse(...handlers: InvokeHandler[]): this;
    get(name: string): MethodLike | undefined;
    add(method: MethodLike): this;
    remove(name: string): this;
    addFunction(f: Function, name?: string): this;
    addMethod(method: Function, target: any, name?: string): this;
    addMethod(name: string, target: any): this;
    addMissingMethod(fn: MissingMethod, target?: any): this;
    addFunctions(functions: Function[], names?: string[]): this;
    addMethods(methods: Function[], target: any, names?: string[]): this;
    addMethods(names: string[], target: any): this;
    addInstanceMethods(target: any, prefix?: string): this;
}
//# sourceMappingURL=Provider.d.ts.map